--
--  testCommand.applescript
--  testTemp
--
--  Created by Takaaki Naganoya on 2015/02/01.
--  Copyright (c) 2015年 Takaaki Naganoya. All rights reserved.
--

script peekCommand
	
	property parent : class "NSScriptCommand"
	
	property aedClass : class "NSAppleEventDescriptor"
	property nssClass : class "NSString"
	property nsnClass : class "NSNumber"

	
	on performDefaultImplementation()
		set paramS to (my directParameter())
        
        set paramDict to my arguments()
        set aParam to (paramDict's valueForKey:"from")
        log {"aParam", aParam}
        set aParam1 to aParam as string
        
        set aFileURL to current application's |NSURL|'s fileURLWithPath:(POSIX path of aParam1)
        log {"aURL", aFileURL}
         
        set bParam to (paramDict's valueForKey:"at")
        log {"bParam", bParam}
        
        set aDat to current application's NSKeyedUnarchiver's unarchiveObjectWithData:bParam
        log {"aDat", aDat}
        
        set xNum to 0
        set yNum to 0

        set cRes to getColorRGBNumFromImageByPosition(aParam, xNum, yNum) of me
        log {"cRes", cRes}
        
		return cRes as list
	end performDefaultImplementation
	
    
	
    on getColorRGBNumFromImageByPosition(aFileURL, xPos as integer, yPos as integer)
        set anNSImage to current application's NSImage's alloc()'s initWithContentsOfURL:aFileURL
        set aRawimg to current application's NSBitmapImageRep's imageRepWithData:(anNSImage's TIFFRepresentation())
        
        set aColor to (aRawimg's colorAtX:xPos y:yPos)
        set aRed to (aColor's redComponent()) * 255
        set aGreen to (aColor's greenComponent()) * 255
        set aBlue to (aColor's blueComponent()) * 255
        
        return {aRed as integer, aGreen as integer, aBlue as integer}
    end getColorRGBNumFromImageByPosition
    
	
	
	
	# ASOC implementation of - (NSAppleEventDescriptor *)scriptingRecordDescriptor for an NSDictionary
	# Creates an empty record descriptor and an empty list descriptor, then
	# Iterates over the dictionary and inserts descriptors for each key and each value into the list descriptor
	# Finally, populates the record descriptor with the type 'usrf' and the list descriptor
	
	on makeUserRecordDescriptor(aDict)
		
		set recordDescriptor to aedClass's recordDescriptor()
		set listDescriptor to aedClass's listDescriptor()
		
		set typeUserField to 1.970500198E+9 -- 'usrf'
		set itemIndex to 1 -- AS records are 1-based
		
		
		
		repeat with aKey in aDict's allKeys()
			
			set aVal to (aDict's valueForKey:aKey)
			
			-- The values can be several different types. This code DOES NOT handle them all.
			set isStringValue to (aVal's isKindOfClass:(nssClass's |class|)) = 1
			set isNumericValue to (aVal's isKindOfClass:(nsnClass's |class|)) = 1
			set isBooleanValue to (aVal's className()'s containsString:"Boolean") = 1
			
			-- Insert a descriptor for the key into the list descriptor
			set anItem to (aedClass's descriptorWithString:aKey)
			(listDescriptor's insertDescriptor:anItem atIndex:itemIndex)
			set itemIndex to itemIndex + 1
			
			-- Insert a descriptor (of the correct type for the value) into the list descriptor
			if isStringValue then
				set anItem to (aedClass's descriptorWithString:aVal)
				
			else if isBooleanValue then
				set anItem to (aedClass's descriptorWithBoolean:(aVal's boolValue()))
				
			else if isNumericValue then
				
				set intValue to aVal's intValue()
				set fpValue to aVal's doubleValue()
				
				if intValue = fpValue then
					set anItem to (aedClass's descriptorWithInt32:(aVal's intValue()))
				else
					set anItem to (aedClass's descriptorWithString:(aVal's stringValue)) # TODO: 'doub'
				end if
				
			else
				--入れ子のリストや入れ子のrecordを返す場合にはここに追記する？
				set anItem to (aedClass's descriptorWithString:"Unhandled Data Type")
				
			end if
			
			(listDescriptor's insertDescriptor:anItem atIndex:itemIndex)
			set itemIndex to itemIndex + 1
			
		end repeat
		
		recordDescriptor's setDescriptor:listDescriptor forKeyword:typeUserField
		
		return recordDescriptor
		
	end makeUserRecordDescriptor
	
	
	
end script
